

/**** Fichiers d'inclusion ****/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <libwebsockets.h>
#include <string.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_tun.h>
#include <sys/types.h>
#include "serveur.h"

/**** constantes ****/
#define TAP_PRINCIPAL   "/dev/net/tun"
/**** globale ****/
/*typedef struct Element{
    char message[350];
    struct Element *next;
} Element;
typedef Element* Queue;*/

char precedent1[300]={0};
char recu[300]={0};
char tmp[LWS_PRE+300]={0};
Queue queue = NULL;

//fonctions permettant la mise en place de la queue

void getMessage(Queue *queue,char *result){
    strncpy(result,(*queue)->message,300);
    Element *tmp= *queue;
    *queue = (*queue)->next;
    free(tmp);
}

void addMessage(Queue *queue,char *trame){
    Element *result=malloc(sizeof(Element));
    result->next = NULL;
    strncpy(result->message,trame,300);
    if (*queue == NULL){
        *queue = result;
    }
    else{
        Queue tmp = *queue;
        while(tmp->next != NULL){
            tmp = tmp->next;
        }
        tmp->next = result;
    }
}

void afficherListe(Queue queue){
    Element *tmp = queue;
    while(tmp != NULL)
    {
        printf("%s\n",tmp->message);
        tmp = tmp->next;
    }
    printf("\n");
}

/**** fonction serveur ****/
static int callback_http(struct lws *wsi,
                         enum lws_callback_reasons reason, void *user,
                         void *in, size_t len)
{
	return 0;
}

static int callback_my(struct lws *wsi,
                                   enum lws_callback_reasons reason,
                                   void *user, void *in, size_t len)
{
    switch (reason) {
        case LWS_CALLBACK_ESTABLISHED: 
            printf("connection etablie\n");
            lws_callback_on_writable(wsi);
            break;

        case LWS_CALLBACK_RECEIVE: {
            memset(recu,'0',300);
   	        memcpy(recu,in,len);
            //printf("trame recue :\n %s \n",recu);
            lws_callback_on_writable(wsi);
            break;    
            }

        case LWS_CALLBACK_SERVER_WRITEABLE: {
            //envoie du paquet ICMP recu par le PING
            if(queue!=NULL){
            getMessage(&queue,&tmp[LWS_PRE]);
            lws_write(wsi,(unsigned char *)&tmp[LWS_PRE],300,LWS_WRITE_TEXT);
            }
            break;
        }
        default:
            break;
    }
    
    return 0;
}

static struct lws_protocols protocols[] = {
    {"http-only",callback_http,0},
    {"my",callback_my,0},
    {NULL, NULL, 0}
};

/*interface virtuelle*/
int creationInterfaceVirtuelle(char *nom)
{
struct ifreq interface;
int fd,erreur;
//struct sockaddr_in sin;

/* Ouverture du peripherique principal */
if((fd=open(TAP_PRINCIPAL,O_RDWR|O_NONBLOCK))<0)return fd;
/* Preparation de la structure */
memset(&interface,0,sizeof(interface));
interface.ifr_flags=IFF_TAP|IFF_NO_PI;
if(nom!=NULL) strncpy(interface.ifr_name,nom,IFNAMSIZ);
/* Creation de l'interface */
if((erreur=ioctl(fd,TUNSETIFF,(void *)&interface))<0){ close(fd); return erreur; }
/* Recuperation du nom de l'interface */
if(nom!=NULL)strcpy(nom,interface.ifr_name);
return fd;
}

///converstion necessaire pour que le systeme comprenne mon message
char converseHexaChar(char val1,char val2){
    char r1,r2,result;

if(val1>='a')
    {r1 = val1 - 'a'+10;}
else
    {r1 = val1 - '0';}
if(val2>='a')
    {r2 = val2 - 'a'+10;}
else
    {r2 = val2 - '0';}

    result = r1 << 4;
    result += r2;
    return result;

}

int conv(char *tab1,char *tab2){

    for(int i=0;i<=300;i++)
    {
        tab2[i]=converseHexaChar(tab1[i*3],tab1[i*3+1]);
    }

return 0;
}

int main(void) {
    int port = 9500;
    int fd;
    unsigned char buffer[120]={0};
    char trame[300]={0};
    
    char *a_name = malloc(IFNAMSIZ);
    strcpy(a_name,"tap0");
    fd=creationInterfaceVirtuelle(a_name);
    struct lws_context_creation_info info;
    memset(&info,0,sizeof info);
    info.port=port;
    info.protocols=protocols;
    info.gid=-1;
    info.uid=-1;

    // create lws context representing this server
    struct lws_context *context = lws_create_context(&info);
        if (context == NULL) {
        fprintf(stderr, "lws init failed\n");
        return -1;
        }
    
    printf("starting server...\n");
    while (1)
    {

///////////////////envoi des donnees recues du simulateur vers l'interface virtuelle.///////////////////
        memset(buffer,'0',120);
        conv(recu,(char *)buffer);
        if(strncmp(precedent1,recu,300)!=0){
            write(fd,buffer,98);
        }
        strncpy(precedent1,recu,300);



/////////////lecture des donnees sur l'interface et construction d'une trame de type String en hexadecimal///////////
        memset(buffer,'0',120);
        if(read(fd,buffer,120)>=0){
            printf("Read bytes from device %s \n", a_name); 
            for(int i=0;i<120;i++)
                { 
                sprintf(&trame[i*3],"%02x",buffer[i]);
                trame[+(i*3)+2]=' ';
                }
           
            addMessage(&queue,trame);
        }

           
	//lancement de la procedure Websocket
        lws_service(context, 50);
    }
    lws_context_destroy(context);

    return 0;
}
